Name:           keyd
Version:        2.5.0
Release:        0%{?dist}
Summary:        A key remapping daemon for linux

License:        MIT
URL:            https://github.com/rvaiya/keyd
Source0:        https://github.com/rvaiya/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz

Patch0:        keyd-Makefile.patch

BuildRequires:  gcc
BuildRequires:  make
BuildRequires:  systemd
BuildRequires:  systemd-rpm-macros
BuildRequires:  libasan

Requires: systemd

%description
Linux lacks a good key remapping solution. In order to achieve satisfactory 
results a medley of tools need to be employed (e.g xcape, xmodmap) with the end
result often being tethered to a specified environment (X11). keyd attempts to
solve this problem by providing a flexible system wide daemon which remaps keys
using kernel level input primitives (evdev, uinput).

Note: this package only provides the keyd daemon.

%prep
%setup -q
# Patch Makefile to use -fPIE
%patch 0 -p0

%build
# Compile with debug symbols to generate debug packages
LDFLAGS="-fPIC" \
CFLAGS="-fPIE" \
PREFIX="/usr" \
%make_build debug

%install
%make_install
# Manual installation for files that can be bypassed by Makefile
install -Dm644 %{name}.service %{buildroot}/%{_unitdir}/%{name}.service
#install -Dm644 #{name}.quirks #{buildroot}/usr/share/libinput/30-#{name}.quirks
# Remove keyd-application-manager
#rm #{buildroot}/#{_datadir}/man/man1/#{name}-application-mapper.1.gz
#rm #{buildroot}/#{_bindir}/#{name}-application-mapper

%files
%license LICENSE
%doc CHANGELOG.md
%doc DESIGN.md
%doc examples
%{_bindir}/%{name}
%{_bindir}/%{name}-application-mapper
#{_datadir}/libinput/30-#{name}.quirks
%{_unitdir}/%{name}.service
%{_datadir}/man/man*/*
%{_datadir}/%{name}/layouts/*
%{_datadir}/%{name}/gnome-extension*/*
%{_datadir}/%{name}/keyd.compose

%pre
# Create group 'keyd'
getent group %{name} || groupadd %{name}

# Scriptlets for packages containing systemd unit files
# Source: Fedora Packaging guidelines

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%changelog
* Thu Dec 05 2024 Ingvar Hagelund <ingvar@redpill-linpro.com> - 2.5.0-0
- Updated to 2.5.0
- Lots of fixes

* Thu Apr 14 2022 Florian Monteghetti <f.monteghetti@gmail.com> - 2.3.1.rc-1
- First Fedora package for keyd.
